unit kolsqlitestatic;
{$HINTS OFF}
{
Legal issues:
             KOL version (c) 2005, Thaddy de Koning
             KOL version adds Delphi stubs, KOL object,
             Delphi STyle naming conventions and corrections the the
             C++ sourcecode for Borland C++ 5.5.
             The objects are distributed as-is.

             Based on the static link version of
             ASGSQlite and subject to the statement below.

             Original Copyright (C) 2003 .. 2005 by Aducom Software

              Aducom Software
              Eckhartstr 61
              9746 BN  Groningen
              Netherlands

              This software is provided 'as-is', without any express or
              implied warranty.  In no event will the author be held liable
              for any damages arising from the use of this software.

              Permission is granted to anyone to use this software for any
              purpose, including commercial applications, and to alter it
              and redistribute it freely, subject to the following
              restrictions:

              1. The origin of this software must not be misrepresented,
                 you must not claim that you wrote the original software.
                 If you use this software in a product, an acknowledgment
                 in the product documentation would be appreciated but is
                 not required.

              2. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              3. If you make changes which improves the component you must
                 mail these to aducom as the moderator of the components
                 complete with documentation for the benefits of the community.

              4. You are not allowed to create commercial available components
                 using this software. If you use this source in any way to create
                 your own components, your source should be free of charge,
                 available to anyone. It's a far better idea to distribute your
                 changes through Aducom Software.

              5. This notice may not be removed or altered from any source
                 distribution.

              6. You must register this software by entering the support forum.
                 I like to keep track about where the components are used, so
                 sending a picture postcard to the author would be appreciated.
                 Use a nice stamp and mention your name, street
                 address, EMail address and any comment you like to say.

Acknowledgement
              These components were written for our own needs. Since SQLite is
              a freeware component we like to donate this one to the community
              too. Parts of the code is adapted from several sources, but mainly
              from a sample and the vcl sources of Borland itself . And, of
              course, we did a lot and still are...
To Do
              A lot...
              We are very busy, but will develop on our needs. If anyone can
              contribute, please feel welcome. Alter the source with lots of comment
              and mail it to me. If it works right I will add it to the official
              source and add your credit here below. Before you start, please
              put a request on the forum. It would be a shame and a waste of your
              time if you develop something which already is...
History:
              Nov 8, 2003 First alpha release 1.0.A Albert Drent (c) 2003 Aducom Software
              Nov 11, Release alpha 1.0.B Albert Drent (c) 2003 Aducom Software
                        - added 'param' support
                        - fixed null pointer assignment
                        - added support for partial select (limit / offset)
              Nov 12, Release alpha 1.0.C Albert Drent (c) 2003 Aducom Software
                        - fixed bug in update
                        - support for events
                        - added 'RowsAffected'
              Nov 16, Release beta 1.0.D Albert Drent (c) 2003 Aducom Software
                        - fixed 0 resultlist after any ExecSQL usage
                        - added Transaction support
              Nov 24, Release beta 1.0.E Albert Drent (c) 2003 Aducom Software
                        - StartTransaction will open database if it is'nt already open
                        - Changed resultset method
                        - Added property editor for table names
                        - Added GetTableNames function to TASQLite3Database
                        - Added GetIndexNames function to TASQLite3Database
                        - Added Open and Close function to TASQLite3Database
                        - Added AutoCommit property to TDataSet descendants
                        - Split of source in designtime and runtime package
              Dec 15, Release beta 1.0.F Albert Drent (c) 2003 Aducom Software
                        - Optimized code for speed
                        - Added support for quering databases
                        - Added property for base directory (default dir) TDatabase
                        - Preparations for mastersets and TUpdateSQL (not functional yet)
                        - Solved GPF on stringfields
                        - Solved hangup of Delphi when developing
                        - Solved invalid pointer operation bug while developing
              Jan 11 2004, Release beta 1.0.G Albert Drent (c) 2003, 2004 Aducom Software
                        - Fixed GetTableNames Bug as reported on forum
                        - Solved some minor bugs, several code optimizations
                        - Added 'getfieldnames' procedure to asqlitedb
                        - Added component asqlitepragma for adjustments to sqlite behaviour
                        - Added several property editors to smooth things up
                        - Added component asqliteupdatesql
                        - Added master-detail support for TASQLite3table (not fully tested yet)
                        - Added master-detail support for TASQLite3query (not fully tested yet)
                        - Added filter property to TASQLite3Query
              Jan 18, 2004, Release beta 1.0.H Albert Drent (c) 2003, 2004 Aducom Software
                        - Added TASQLite3Log component
                        - Support for autoincrement (index primary key)
              Jan 22, 2004, Release beta 1.0.I Albert Drent (c) 2003, 2004 Aducom Software
                        - Solved bug, causing the user to open database first (where
                          it should be opened automatically after open query or table.
                        - datatype text is now treated as a string of max 255 chars.
                        - added samples
                        - added preparations for import and export component
              Jan 26, 2004, Release beta 1.1.A Albert Drent (c) 2003, 2004 Aducom Software
                        - Support for master-detail
                        - Support for TUpdateSQL
              Feb 05, 2004, Release beta 1.1.B Albert Drent (c) 2003, 2004 Aducom Software
                        - Solved small bug: basequery is closed on querychanged event
                        - Solved small bug: basequery is closed on filter change event
                        - Solved bug in design package, by Marc Wetzel(forum)
                        - Notification of BaseQuery removed and added to SQLiteTable
              Feb 24, 2004 Release alpha 1.2.A Albert Drent (c) 2003, 2004 Aducom Software
                        - Locate implemented, working on resultset!
                        - Some small bugfixes
              Feb 25, 2004 Release alpha 1.2.B Albert Drent (c) 2003, 2004 Aducom Software
                        - Reformat of source (Marc Wetzel)
                        - All the debug directives (Marc Wetzel)
                          The debug stuff is added to be able to do more debugging on the
                          components. At this stage there are still some isues which are
                          hard to be find.
                        - Some small bugfixes (Marc Wetzel)
                        - Solved bug with dblookupcombobox, lookup is now shown (variant error)
                        - Derived more classes from TDataset to solve compatibility isues with
                          3rd party software (DevExpress)
                        - Start of port to lower Delphi versions (designintf vs dsgnintf)
              March 25, 2004 Release alpha 1.2.C Albert Drent (c) 2003, 2004 Aducom Software
                        - Added property editor for database directory
                        - Added property editor for sqlitedll directory
                        - Bugix needed for release 13 of SQLite.dll (is compatible to lower
                          dll versions)
                        - More changes to solve compatibility problem with DevExpress (Plato of DevExpress)
                        - Solved some compatibility isues with TDataSet
                        - Solved some compatibility isues with the newest SQLite version (2.8.12)
                        - Added/modified, GetFieldNames, GetPrimaryKeys
                        - Added GetTableInfo
                        - Added StartTransaction and Commit and RollBack to TTable and TQuery
                          This will create a more readable source:
                             db.starttranaction;
                             q.somesql
                             db.commit
                          becomes now
                             with q do begin
                               starttransaction;
                               somesql;
                               try
                                 commit;
                               except
                                 rollback;
                               end;
                             end;
                        - Changed cleanup of components in notification (TheSneak)
                        - Fixed potential AV (so far not reported)
                        - Changed escape of string characters (TheSneak)
                          (might cause incompatibility of older components if you use single
                          quote in data)
                        - Fixed question mark problem in data (TheSneak)
              April 7, 2004
                        - Fixed bug GetxxxxNames, moved pragma (reported by Martini)
                        - Improved some performance isues (TheSneak)
                        - Added GetTableIndexNames(by Martini)
                        - Added support for 'small text blobs', it isn't the real stuff but
                          limited to 20000 characters.
                        - Fixed another compatibility isue with DevExpress
              April 8, 2004
                        - Fixed EnableControls (TheSneak)
                        - Fixed memoryleak ASQLiteQuery.InternalPost (TheSneak)
                        - Downgraded some stuff for support Delphi 4/5
                        - Updated Locate function (by Joel  hottcha@juno.com)
              April 14, 2004 Release beta 1.2.C Albert Drent (c) 2003, 2004 Aducom Software
                        - RawSQL property implemented (supresses parsing of sql data)
                        - published csv release as 1.2.C beta
              April 15, 2004 Release alpha 2.0.A Albert Drent (c) 2003, 2004 Aducom Software
                        - support for real clobs
                        - added fieldtype numeric(x.y)
                        - Implement RawSQL property in TASQLite3Query
              May 26, 2004 Release beta 2.0.B Albert Drent (c) 2003, 2004 Aducom Software
                        - new procedure: GetGetLastInsertRow
                        - new component: TASQLite3InlineSQL, to be used to contain all
                          kinds of pre-stored sql statements. I.e. for creation of tables in case
                          of an in-memory database, or a local storage for sql statements to
                          simplify sourcecode. In this release it is bound to the ASQLiteDB component.
                        - new component TASQLite3Output, to be used to generate csv files,
                          xml and html documents. It is NOT bound to ASQLite components but
                          to a datasource (containing any database connection)
                        - implemented bound as described by minhl on the forum
                        - implemented IsNull as described by Kazooie64 on the forum
                        - implemented a uniform datetime implementation by jpierce
              May, 26, 2004 Release beta 2.0.B Albert Drent (c) 2003, 2004 Aducom Software
                        - A few bugfixes
              June, 15, 2004 Release beta 2.0.C Albert Drent (c) 2003, 2004 Aducom Software
                        - A few bugfixes, thanks to Tzvetan
              July 2004, Release 1.0 based upon source sqlite version 2 components
              Okt 11, 2004 Release beta 1.0.B Albert Drent (c) 2003, 2004 Aducom Software
                        - Callback routine for retieving data replaced by new
                          by sqlite prefered way.
                        - Some bugfixes
                        - Support for calculated fields
                        - Support for real blobs
              okt 14, 2004 Release beta 1.0.C Albert Drent (c) 2003, 2004 Aducom Software
                        - support for locate lo-partial key (thanks to Bob Mitchel)
                        - some bugfixes (thanks to Oleg Lembievskiy marked by OL)
                        - some other bugfixes and code cleanup
              okt 18, 2004
                        - re-introduced sqlite_version
                        - added transactiontype property(SQLite3 feature)
                        - added transaction procedures to db and basequery
                                StartDeferredTransaction;
                                StartImmediateTransaction;
                                StartExclusiveTransaction;
              nov 1, 2004
                        - bugfix (thanx to James) for null pointer assignment on null values
              nov 8, 2004
                        - fixed introduced bug in result preventing new records to appear
                          right in dbgrids.
              nov 17, 2004
                        - fixed small bug showing rubish on empty tables
              Nov 17, 2004 by Mike Dijkema
                        - filter bug  FPrepared := FPrepared + ' and ' + Filter adds ' and filterexpr' to the end of the sql statement
                          this created errors with 'order by' 'limit' 'union' 'having' etc..
                          filtering changed to that it works like the ADO components and union and other statements
                          now 'select a from b union select c from d' and 'select a from b order by c' works with a filter
                        - filter bug 'select a_where from b' removed
              jan 11, 2005 Release 2005.01.A Albert Drent (c) 2003 .. 2005 Aducom Software
                        - fixed bug causing fielddescription to be deleted incorrectly
                        - fixed bug causing errormessage on null values in integer fields
                        - added sqlcursor property
                        - modifications to support Delphi 2005
                        - implemented all transactiontypes
                        - changed all showmessages to raise event types
                        - added readonly property
              feb 21, 2005 Release 2005.02.A Albert Drent (c) 2003 .. 2005 Aducom Software
                        - some bugfixes, code optimization
                        - first implementation of IProvider support (thanks to
                          Rocco Barbaresco)
                        - changed default SDB extension to SQB
                        - support for multi sql statements in one string
                        - added master-detail functionality on insert of
                          new child record (key-data is copied)
                        - added compatibility with SQLite3.dll version 3.1.2
              feb 28, 2005 Release 2005.02.B Albert Drent (c) 2003 .. 2005 Aducom Software
                        - bugfix for filter on master-detail. Setting filtered will
                          not automatical open table any more. Causes error on closed
                          tables in master-detail otherwise.
              mar 7, 2005 Release 2005.03.A Albert Drent (c) 2003 .. 2005 Aducom Software
                        - bugfix for memofields causing crlf to be handled wrongly
                        - added TableExists function ('// DI  Ralf http://www.yunqa.de/delphi/)
                        - some code optimizations ('// DI Ralf http://www.yunqa.de/delphi/)
                        - solved decimalpoint bug ('// DI Ralf http://www.yunqa.de/delphi/)
              mar 10, 2005 Release 2005.03.B Albert Drent (c) 2003 .. 2005 Aducom Software
                        - more code optimizations
                        - removed Forms from uses list to decrease codesize of console app's
                        - changed cursorstyle handling
                        - changed exception handling
              mar 29, 2005 Release 2005.03.C Albert Drent (c) 2003 .. 2005 Aducom Software
                        - removed default pragma's for tables
                        - implemented another solution for tableheader duplicates (mirko)
                        - implemented user version
                        - solved minor bug in GetTableInfo
              april 5, 2005 Release 2005.04.A Albert Drent (c) 2003 .. 2005 Aducom Software
                        - fixed bug conceirning in-memory database (Bert Verhees)
                        - fixed precompiler settings for Delhpi 7 (Dak)
              mai 31, 2005 Release 2005.05.A Albert Drent (c) 2003 .. 2005 Aducom Software
                        - UTF8 support (thanks to
                        - Statical linking (thanks to Gianpaolo Avallone (GPA)
                        - Some bugfixes and enhancements by Albert, Gianpaolo and others.


* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
KOL STATIC VERSION INFO
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


              August 8, 2005: KOL beta 1 release, Linker issues fixed,
                              KOL object introduced. Unit clean up for KOL.
                              introduced proper Delphi memory management.
                              (Use FastMM4.pas for High Performance);
                              Note I will have to do a full rebuild to create
                              better linking. Do that when I have the time.
*_* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * }

interface
uses Kol,Windows,Messages, err;

type
  PPointer = ^Pointer;

const
  SQLiteVersion     = 'KOLSQLite V1.00B';

  MaxBuf            = 30000;            // max stringbuffer for record (length) (excluding blob's)
  SQLITE_OK         = 0;                // Successful result */
  SQLITE_ERROR      = 1;                // SQL error or missing database */
  SQLITE_INTERNAL   = 2;                // An internal logic error in SQLite */
  SQLITE_PERM       = 3;                // Access permission denied */
  SQLITE_ABORT      = 4;                // Callback routine requested an abort */
  SQLITE_BUSY       = 5;                // The database file is locked */
  SQLITE_LOCKED     = 6;                // A table in the database is locked */
  SQLITE_NOMEM      = 7;                // A malloc() failed */
  SQLITE_READONLY   = 8;                // Attempt to write a readonly database */
  SQLITE_INTERRUPT  = 9;                // Operation terminated by sqlite_interrupt() */
  SQLITE_IOERR      = 10;               // Some kind of disk I/O error occurred */
  SQLITE_CORRUPT    = 11;               // The database disk image is malformed */
  SQLITE_NOTFOUND   = 12;               // (Internal Only) Table or record not found */
  SQLITE_FULL       = 13;               // Insertion failed because database is full */
  SQLITE_CANTOPEN   = 14;               // Unable to open the database file */
  SQLITE_PROTOCOL   = 15;               // Database lock protocol error */
  SQLITE_EMPTY      = 16;               // (Internal Only) Database table is empty */
  SQLITE_SCHEMA     = 17;               // The database schema changed */
  SQLITE_TOOBIG     = 18;               // Too much data for one row of a table */
  SQLITE_CONSTRAINT = 19;               // Abort due to contraint violation */
  SQLITE_MISMATCH   = 20;               // Data type mismatch */
  SQLITE_MISUSE     = 21;               // Library used incorrectly */
  SQLITE_NOLFS      = 22;               // Uses OS features not supported on host */
  SQLITE_AUTH       = 23;               // Authorization denied */
  SQLITE_ROW        = 100;              // sqlite_step() has another row ready */
  SQLITE_DONE       = 101;              // sqlite_step() has finished executing */

  SQLITE_CREATE_INDEX = 1;              // Index Name      Table Name      */
  SQLITE_CREATE_TABLE = 2;              // Table Name      NULL            */
  SQLITE_CREATE_TEMP_INDEX = 3;         // Index Name      Table Name      */
  SQLITE_CREATE_TEMP_TABLE = 4;         // Table Name      NULL            */
  SQLITE_CREATE_TEMP_TRIGGER = 5;       // Trigger Name    Table Name      */
  SQLITE_CREATE_TEMP_VIEW = 6;          // View Name       NULL            */
  SQLITE_CREATE_TRIGGER = 7;            // Trigger Name    Table Name      */
  SQLITE_CREATE_VIEW = 8;               // View Name       NULL            */
  SQLITE_DELETE     = 9;                // Table Name      NULL            */
  SQLITE_DROP_INDEX = 10;               // Index Name      Table Name      */
  SQLITE_DROP_TABLE = 11;               // Table Name      NULL            */
  SQLITE_DROP_TEMP_INDEX = 12;          // Index Name      Table Name      */
  SQLITE_DROP_TEMP_TABLE = 13;          // Table Name      NULL            */
  SQLITE_DROP_TEMP_TRIGGER = 14;        // Trigger Name    Table Name      */
  SQLITE_DROP_TEMP_VIEW = 15;           // View Name       NULL            */
  SQLITE_DROP_TRIGGER = 16;             // Trigger Name    Table Name      */
  SQLITE_DROP_VIEW  = 17;               // View Name       NULL            */
  SQLITE_INSERT     = 18;               // Table Name      NULL            */
  SQLITE_PRAGMA     = 19;               // Pragma Name     1st arg or NULL */
  SQLITE_READ       = 20;               // Table Name      Column Name     */
  SQLITE_SELECT     = 21;               // NULL            NULL            */
  SQLITE_TRANSACTION = 22;              // NULL            NULL            */
  SQLITE_UPDATE     = 23;               // Table Name      Column Name     */
  SQLITE_ATTACH     = 24;               // Filename        NULL            */
  SQLITE_DETACH     = 25;               // Database Name   NULL            */

  SQLITE_DENY       = 1;                // Abort the SQL statement with an error */
  SQLITE_IGNORE     = 2;                // Don't allow access, but don't generate an error */

  Crlf              : string = #13#10;
  Q                 = '''';

type
  pInteger = ^integer;

  pSmallInt = ^smallint;
  pFloat = ^extended;
  pBoolean = ^boolean;

  TConvertBuffer = array[1..255] of char;

  TSQLite3_Callback = function(UserData: Pointer; ColumnCount: Integer; ColumnValues, ColumnNames: PPointer): Integer; cdecl;
//  TSQLiteExecCallback = function(Sender: TObject; Columns: integer; ColumnValues: Pointer; ColumnNames: Pointer): integer of object; cdecl;
  TSQLiteBusyCallback = function(Sender: TObject; ObjectName: PAnsiChar; BusyCount: integer): integer of object; cdecl;
  TOnData = procedure(Sender: TObject; Columns: integer; ColumnNames, ColumnValues: string) of object;
  TOnBusy = procedure(Sender: TObject; ObjectName: string; BusyCount: integer; var Cancel: boolean) of object;
  TOnQueryComplete = procedure(Sender: TObject) of object;
  TASQLite3NotifyEvent = procedure(Sender: TObject) of object;

  // structure for holding field information. It is used by GetTableInfo

  TASQLite3Field = class
  public
    FieldNumber: integer;
    FieldName: string;
    FieldType: string;
    FieldNN: integer;                   // 1 if notnull
    FieldDefault: string;
    FieldPK: integer;                   // 1 if primary key
  end;



type

PKolSqlite3 = ^TKolSqlite3;
TKolSqlite3 = object(Tobj)
private
    DllHandle:THandle;
//    FCharEncoding: string;
public
    Open: function(dbname: PAnsiChar; var db: pointer): integer; cdecl;
    Close: function(db: pointer): integer; cdecl;
    Exec: function(DB: Pointer; SQLStatement: PAnsiChar; Callback: TSQLite3_Callback;
                           UserDate: Pointer; var ErrMsg: PAnsiChar): Integer; cdecl;
    LibVersion: function(): PAnsiChar; cdecl;
    ErrorString: function(db: pointer): PAnsiChar; cdecl;
    GetTable: function(db: Pointer; SQLStatement: PAnsiChar; var ResultPtr: Pointer;
      var RowCount: cardinal; var ColCount: cardinal; var ErrMsg: PAnsiChar): integer; cdecl;
    FreeTable: procedure(Table: PAnsiChar); cdecl;
    FreeMem: procedure(P: PAnsiChar); cdecl;
    Complete: function(P: PAnsiChar): boolean; cdecl;
    LastInsertRow: function(db: Pointer): integer; cdecl;
    Cancel: procedure(db: Pointer); cdecl;
    BusyHandler: procedure(db: Pointer; CallbackPtr: Pointer; Sender: TObject); cdecl;
    BusyTimeout: procedure(db: Pointer; TimeOut: integer); cdecl;
    Changes: function(db: Pointer): integer; cdecl;
    Prepare: function(db: Pointer; SQLStatement: PAnsiChar; nBytes: integer;
      var hstatement: pointer; var Tail: PAnsiChar): integer; cdecl;
    Finalize: function(hstatement: pointer): integer; cdecl;
    Reset: function(hstatement: pointer): integer; cdecl;
    Step: function(hstatement: pointer): integer; cdecl;
    ColumnBlob: function(hstatement: pointer; iCol: integer): pointer; cdecl;
    ColumnBytes: function(hstatement: pointer; iCol: integer): integer; cdecl;
    ColumnCount: function(hstatement: pointer): integer; cdecl;
    ColumnDecltype: function(hstatement: pointer; iCol: integer): PAnsiChar; cdecl;
    ColumnDouble: function(hstatement: pointer; iCol: integer): double; cdecl;
    ColumnInt: function(hstatement: pointer; iCol: integer): integer; cdecl;
    ColumnInt64: function(hstatement: pointer; iCol: integer): int64; cdecl;
    ColumnName: function(hstatement: pointer; iCol: integer): PAnsiChar; cdecl;
    ColumnText: function(hstatement: pointer; iCol: integer): PAnsiChar; cdecl;
    ColumnType: function(hstatement: pointer; iCol: integer): integer; cdecl;
    BindBlob: function(hstatement: pointer; iCol: integer; buf: PAnsiChar; n: integer; DestroyPtr: Pointer): integer; cdecl;
    procedure init;virtual;
end;

implementation

function _malloc(const Size: Cardinal): Pointer;cdecl;
begin
  GetMem(Result, Size);
end;

{ ---------------------------------------------------------------------------- }

procedure _free(const p: Pointer); cdecl;
begin
  FreeMem(p);
end;

{ ---------------------------------------------------------------------------- }

function _memcpy(Dest: Pointer; const Src: Pointer; n: Cardinal): Pointer; cdecl;
begin
  Result := Dest;
  Move(Src^, Result^, n);
end;

{ ---------------------------------------------------------------------------- }

function _memset(const Source: Pointer; const Value: Integer; const Count: Cardinal): Pointer; cdecl;
begin
  Result := Source;
  FillChar(Result^, Count, Value);
end;

Var
  __HandlerPtr:Pointer;

function _StrLen(const Str: PChar): Cardinal;cdecl;
begin
  Result:=strlen(str);
end;


procedure __abort;cdecl;
begin
  Abort;
end;

procedure _abort;cdecl;
begin
  __Abort;
end;


  {$L 'sqlite3.obj'}
  {$L 'files.obj'}
//  {$L 'strlen.obj'}
  {$L 'assert.obj'}
  {$L 'memcmp.obj'}
//  {$L 'memcpy.obj'}
//  {$L 'memset.obj'}
  {$L 'strcmp.obj'}
  {$L 'strcpy.obj'}
  {$L 'strcat.obj'}
  {$L 'strncmp.obj'}
  {$L 'strncpy.obj'}
  {$L 'strncat.obj'}
  {$L 'sprintf.obj'}
  {$L 'fprintf.obj'}
  {$L '_ll.obj'}
  {$L 'ltoupper.obj'}
  {$L 'ltolower.obj'}
  {$L 'atol.obj'}
  {$L 'ftol.obj'}
  {$L 'longtoa.obj'}
  {$L 'hrdir_r.obj'}
  {$L 'gmtime.obj'}
  {$L 'tzdata.obj'}
  {$L 'initcvt.obj'}
  {$L 'streams.obj'}
  {$L 'scantod.obj'}
  {$L 'scanwtod.obj'}
  {$L 'allocbuf.obj'}
  {$L 'bigctype.obj'}
  {$L 'clocale.obj'}
  {$L 'clower.obj'}
  {$L 'cupper.obj'}
  {$L 'fflush.obj'}
  {$L 'fputn.obj'}
  {$L 'hrdir_s.obj'}
  {$L 'mbisspc.obj'}
  {$L 'mbsrchr.obj'}
  {$L 'realcvt.obj'}
  {$L 'realcvtw.obj'}
  {$L 'timefunc.obj'}
  {$L 'vprinter.obj'}
  {$L 'hugeval.obj'}
  {$L 'cvtfak.obj'}
  {$L 'getinfo.obj'}
  {$L 'qmul10.obj'}
  {$L 'fuildq.obj'}
  {$L '_pow10.obj'}
  {$L 'ldtrunc.obj'}
  {$L 'cvtfakw.obj'}
  {$L 'wis.obj'}
  {$L 'xfflush.obj'}
  {$L 'flushout.obj'}
  {$L 'lputc.obj'}
  {$L 'hrdir_b.obj'}
  {$L 'realloc.obj'}
  {$L 'mbctype.obj'}
  {$L 'xcvt.obj'}
  {$L 'xcvtw.obj'}
  {$L 'wcscpy.obj'}
  {$L 'errno.obj'}
  {$L 'ctrl87.obj'}
  {$L 'timedata.obj'}
  {$L 'int64toa.obj'}
  {$L 'cvtentry.obj'}
  {$L 'mbyte1.obj'}
  {$L 'errormsg.obj'}
  {$L 'exit.obj'}
  {$L 'iswctype.obj'}
  {$L 'heap.obj'}
  {$L 'memmove.obj'}
  {$L 'fxam.obj'}
  {$L 'fuistq.obj'}
  {$L 'qdiv10.obj'}
  {$L 'wmemset.obj'}
  {$L 'wcslen.obj'}
  {$L '_tzset.obj'}
  {$L 'deflt87.obj'}
  {$L 'mbschr.obj'}
  {$L 'mbsrchr.obj'}
  {$L 'ermsghlp.obj'}
  {$L 'patexit.obj'}
  {$L 'initexit.obj'}
  {$L 'virtmem.obj'}
  {$L 'tzset.obj'}
  {$L 'mbisdgt.obj'}
  {$L 'mbsnbcpy.obj'}
  {$L 'platform.obj'}
  {$L 'getenv.obj'}
  {$L 'mbisalp.obj'}
//  {$L 'abort.obj'}
  {$L 'signal.obj'}
  {$L 'clear87.obj'}
//  {$L 'abort.obj'}
  {$L 'handles.obj'}
  {$L '_cfinfo.obj'}
  {$L '__isatty.obj'}
 // {$L 'handles.obj'}  //duplicato
  {$L 'perror.obj'}
  {$L 'fputs.obj'}
  {$L 'files2.obj'}
  {$L 'handles.obj'}  //duplicato 2
  {$L 'ioerror.obj'}
  {$L 'perror.obj'}   //duplicato
  {$L '__write.obj'}
  {$L '_write.obj'}
  {$L '__lseek.obj'}
  {$L 'ioerror.obj'}
  {$L 'setenvp.obj'}
  {$L 'calloc.obj'}
  {$L 'mbsnbcmp.obj'}
  {$L 'mbsnbicm.obj'}
  {$L 'is.obj'}
  {$L 'isctype.obj'}
  {$L 'bigctype.obj'}
  {$L 'globals.obj'}
//  {$L 'hrdir_mf.obj'}
  {$L 'fpreset.obj'}
  {$L 'ta.obj'}
  {$L 'setexc.obj'}
  {$L 'defhandl.obj'}

  function _wsprintfA:integer; external 'user32.dll' name 'wsprintfA';
  procedure RtlUnwind; external 'NtDll.dll' name 'RtlUnwind';

  function  _sqlite3_open(dbname: PAnsiChar; var db: pointer): integer; cdecl; external;
  function  _sqlite3_close(db: pointer): integer; cdecl; external;
  function  _sqlite3_exec(DB: Pointer; SQLStatement: PAnsiChar; Callback: TSQLite3_Callback;
                          UserDate: Pointer; var ErrMsg: PAnsiChar): Integer; cdecl; external;
  function  _sqlite3_libversion: PAnsiChar; cdecl; external;
  function  _sqlite3_errmsg(db: pointer): PAnsiChar; cdecl; external;
  function  _sqlite3_get_table(db: Pointer; SQLStatement: PAnsiChar; var ResultPtr: Pointer;
                              var RowCount: cardinal; var ColCount: cardinal; var ErrMsg: PAnsiChar): integer; cdecl; external;
  procedure _sqlite3_free_table(Table: PAnsiChar); cdecl; external;
  procedure _sqlite3_free(P: PAnsiChar); cdecl; external;
  function  _sqlite3_complete(P: PAnsiChar): boolean; cdecl; external;
  function  _sqlite3_last_insert_rowid(db: Pointer): integer; cdecl; external;
  procedure _sqlite3_interrupt(db: Pointer); cdecl; external;
  procedure _sqlite3_busy_handler(db: Pointer; CallbackPtr: Pointer; Sender: TObject); cdecl; external;
  procedure _sqlite3_busy_timeout(db: Pointer; TimeOut: integer); cdecl; external;
  function  _sqlite3_changes(db: Pointer): integer; cdecl; external;
  function  _sqlite3_prepare(db: Pointer; SQLStatement: PAnsiChar; nBytes: integer;
                             var hstatement: pointer; var Tail: PAnsiChar): integer; cdecl; external;
  function  _sqlite3_finalize(hstatement: pointer): integer; cdecl; external;
  function  _sqlite3_reset(hstatement: pointer): integer; cdecl; external;
  function  _sqlite3_step(hstatement: pointer): integer; cdecl; external;
  function  _sqlite3_column_blob(hstatement: pointer; iCol: integer): pointer; cdecl; external;
  function  _sqlite3_column_bytes(hstatement: pointer; iCol: integer): integer; cdecl; external;
  function  _sqlite3_column_count(hstatement: pointer): integer; cdecl; external;
  function  _sqlite3_column_decltype(hstatement: pointer; iCol: integer): PAnsiChar; cdecl; external;
  function  _sqlite3_column_double(hstatement: pointer; iCol: integer): double; cdecl; external;
  function  _sqlite3_column_int(hstatement: pointer; iCol: integer): integer; cdecl; external;
  function  _sqlite3_column_int64(hstatement: pointer; iCol: integer): int64; cdecl; external;
  function  _sqlite3_column_name(hstatement: pointer; iCol: integer): PAnsiChar; cdecl; external;
  function  _sqlite3_column_text(hstatement: pointer; iCol: integer): PAnsiChar; cdecl; external;
  function  _sqlite3_column_type(hstatement: pointer; iCol: integer): integer; cdecl; external;
  function  _sqlite3_bind_blob(hstatement: pointer; iCol: integer; buf: PAnsiChar; n: integer; DestroyPtr: Pointer): integer; cdecl; external;

{ TKolSqlite3 }


procedure TKolSqlite3.init;
begin
      inherited;
      DllHandle := 1;
      Open := @_sqlite3_open;
      Close := @_sqlite3_close;
      Exec := @_sqlite3_exec;
      LibVersion := @_sqlite3_libversion;
      ErrorString := @_sqlite3_errmsg;
      GetTable := @_sqlite3_get_table;
      FreeTable := @_sqlite3_free_table;
      FreeMem := @_sqlite3_free;
      Complete := @_sqlite3_complete;
      LastInsertRow := @_sqlite3_last_insert_rowid;
      Cancel := @_sqlite3_interrupt;
      BusyTimeout := @_sqlite3_busy_timeout;
      BusyHandler := @_sqlite3_busy_handler;
      Changes := @_sqlite3_changes;
      Prepare := @_sqlite3_prepare;
      Finalize := @_sqlite3_finalize;
      Reset := @_sqlite3_reset;
      Step := @_sqlite3_step;
      ColumnBlob := @_sqlite3_column_blob;
      ColumnBytes := @_sqlite3_column_bytes;
      ColumnCount := @_sqlite3_column_count;
      ColumnDecltype := @_sqlite3_column_decltype;
      ColumnDouble := @_sqlite3_column_double;
      ColumnInt := @_sqlite3_column_int;
      ColumnInt64 := @_sqlite3_column_int64;
      ColumnName := @_sqlite3_column_name;
      ColumnText := @_sqlite3_column_text;
      ColumnType := @_sqlite3_column_type;
      BindBlob := @_sqlite3_bind_blob;
end;

end.
















